.386
.model flat,stdcall
option casemap:none

include color_izer2.inc

RGB2HSL         PROTO :DWORD
HSL2RGB         PROTO :DWORD
Compute_RGB     PROTO
Compute_HSL     PROTO
CreateHSLpal    PROTO
Set_Sliders_RGB PROTO
Set_Sliders_HSL PROTO
RGB_proc        PROTO :DWORD,:DWORD
st_Init         PROTO :DWORD
st_Paint        PROTO :DWORD
st_Popup        PROTO :DWORD
st_Comm         PROTO :DWORD,:DWORD
st_Click        PROTO :DWORD,:DWORD,:DWORD
DlgProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
	;initial color
	color     dd 0
	;lengths of sliders lines'
	slide_len1 dd 140
	slide_len2 dd 140
	slide_len3 dd 140
	
	maxX1      dd 127
	maxX2      dd 127
	maxX3      dd 127
	;icon handles
	cur_RGB  dd 0
	cur_R    dd 0
	cur_G    dd 0
	cur_B    dd 0
	;x values [0..127]
	cur_RGBx dd 0
	cur_Rx   dd 0
	cur_Gx   dd 0
	cur_Bx   dd 0
	;double buffer for icons
	mdc_RGB  dd 0
	mdc_Cur  dd 0
	;current color
	CCol_rc  RECT < 76,  29, 111,  64>
	;rect structure for all icons relative to 0
	RGB_rc   RECT <  0,   0, 140,  48>
	Cur_rc   RECT <  0,   0, 140,  32>
	Cur_rc1  RECT <  0,   0,   6,  20>
	Cur_rc2  RECT <134,   0, 140,  19>
	Cur_rc3  RECT <  0,  19, 140,  32>
	;rect structures for every icon relative to client area
	RGB_RC   RECT < 70,  89, 210, 102>
	R_rc     RECT < 70, 120, 210, 136>
	G_rc     RECT < 70, 136, 210, 152>
	B_rc     RECT < 70, 152, 210, 168>
	INV_rc0  RECT <  4,   4, 150,  30>
	INV_rc1  RECT <  4,  30, 210, 168>
	;rect structure for palette relative to client area
	PAL_rc   RECT < 10,  30,  60, 165>
	;rect structure for hex-value relative to client area
	VAL_HEX  RECT < 10,   2,  70,  20>
	;text color of hex-value
	text_col dd 00000000h, 00000000h, 00ff0000h, 00ff0000h, 00008000h, 00008000h, 000000ffh, 000000ffh
	;should mouse cursor be isolated 0-no 1-yes
	locked   dd 0
	;font handle for hex-value
	font_HEX dd 0
	;width of one symbol in current font
	font_cx  dd 0
	;color-value
	RGB_HEX  dd 0
	result   dd 0
	;colors for standard palette
	standard_pal dd 00ffffffh,00c0c0c0h,00808080h
	             dd 0000ffffh,0000c0c0h,00008080h
	             dd 00ffff00h,00c0c000h,00808000h
	             dd 000000ffh,000000c0h,00000080h
	             dd 00c0ffc0h,0000ff00h,00008000h
	             dd 00ff8080h,00ff0000h,00800000h
	             dd 00ff80ffh,00ff00ffh,00800080h
	             dd 00808080h,00404040h,00000000h
	;colors for other palette
	custom_pal   dd 24 dup (0)
	Cur_Model    dd 0
	;
	text_rgb     db "RGB(",0
	text_hsl     db "HSL(",0
	text_comma   db ",",0
	text_brac    db 29h,0
	text_space   db "                    ",0
	;
	text_mode    dd 0
	col_popup    dd 0
	;REALS
	R05 REAL8 0.5
.data?
	hInstance dd ?

.code

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD

    push    hInst
    pop     hInstance
    mov     eax, TRUE
    ret

DllEntry Endp

Color_izer proc hWin:DWORD, init_color:DWORD

	mov    eax,   init_color
	mov    color, eax
	invoke DialogBoxParam, hInstance, 101, hWin, ADDR DlgProc, 0
	ret
	
Color_izer endp

DlgProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	mov	    eax, uMsg
	.if eax==WM_INITDIALOG
		invoke st_Init, hWin
		
	.elseif eax==WM_LBUTTONDOWN || eax==WM_LBUTTONUP || eax==WM_MOUSEMOVE	
		invoke st_Click, hWin, uMsg, lParam
	
	.elseif eax==WM_RBUTTONUP
		invoke st_Popup, hWin	
	
	.elseif eax==WM_PAINT
		invoke st_Paint, hWin
		
	.elseif eax==WM_COMMAND
		invoke st_Comm, hWin, wParam
		
	.elseif eax==WM_CLOSE
		invoke DeleteDC,    mdc_RGB
		invoke DeleteDC,    mdc_Cur
		invoke DestroyIcon, cur_R
		invoke DestroyIcon, cur_G
		invoke DestroyIcon, cur_B
		invoke DestroyIcon, cur_RGB
		invoke DestroyMenu, col_popup
		invoke EndDialog,   hWin, -1
	.else
		mov	   eax, FALSE
		ret
	.endif
	mov	   eax, TRUE
	ret

DlgProc endp

st_Init proc hWin:DWORD
	LOCAL dc:DWORD
	LOCAL hbit:DWORD
	LOCAL tm:TEXTMETRIC
	
	mov    col_popup, FUNC(CreatePopupMenu)
	invoke AppendMenu, col_popup, MF_STRING, 10000, CADD("Toggle dec mode")
	
	invoke MemCopy, ADDR standard_pal, ADDR custom_pal, 24*4
	invoke SendDlgItemMessage, hWin, 1004, CB_ADDSTRING, 0, CADD("RGB")
	invoke SendDlgItemMessage, hWin, 1004, CB_ADDSTRING, 0, CADD("HSL")
	;invoke SendDlgItemMessage, hWin, 1004, CB_ADDSTRING, 0, CADD("HSV") ;TODO
	invoke SendDlgItemMessage, hWin, 1004, CB_SETCURSEL, 0, 0
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("NONE")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("0_SCROLLBAR")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("1_DESKTOP")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("2_ACTIVECAPTION")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("3_INACTIVECAPTION")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("4_MENU")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("5_WINDOW")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("6_WINDOWFRAME")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("7_MENUTEXT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("8_WINDOWTEXT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("9_CAPTIONTEXT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("10_ACTIVEBORDER")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("11_INACTIVEBORDER")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("12_APPWORKSPACE")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("13_HIGHLIGHT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("14_HIGHLIGHTTEXT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("15_BTNFACE")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("16_BTNSHADOW")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("17_GRAYTEXT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("18_BTNTEXT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("19_INACTIVECAPTIONTEXT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("20_BTNHIGHLIGHT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("21_3DDKSHADOW")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("22_3DLIGHT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("23_INFOTEXT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("24_INFOBK")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("25_-")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("26_HOTLIGHT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("27_GRADIENTACTIVECAPTION")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("28_GRADIENTINACTIVECAPTION")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("29_MENUHILIGHT")
	invoke SendDlgItemMessage, hWin, 1005, CB_ADDSTRING, 0, CADD("30_MENUBAR")
	invoke SendDlgItemMessage, hWin, 1005, CB_SETCURSEL, 0, 0
	mov    cur_RGB, FUNC(LoadImage, hInstance, 40000, IMAGE_ICON, 13, 13, LR_DEFAULTCOLOR)
	mov    cur_R,   FUNC(LoadImage, hInstance, 40001, IMAGE_ICON, 13, 13, LR_DEFAULTCOLOR)
	mov    cur_G,   FUNC(LoadImage, hInstance, 40002, IMAGE_ICON, 13, 13, LR_DEFAULTCOLOR)
	mov    cur_B,   FUNC(LoadImage, hInstance, 40003, IMAGE_ICON, 13, 13, LR_DEFAULTCOLOR)
	
	mov    dc,      FUNC(GetDC, hWin)
	mov    mdc_RGB, FUNC(CreateCompatibleDC,     dc)
	mov    hbit,    FUNC(CreateCompatibleBitmap, dc, 140, 48)
	invoke SelectObject, mdc_RGB, eax
	invoke DeleteObject, eax
	invoke DeleteObject, hbit
	
	mov    mdc_Cur, FUNC(CreateCompatibleDC,     dc)
	mov    hbit,    FUNC(CreateCompatibleBitmap, dc, 140, 32)
	invoke SelectObject, mdc_Cur, eax
	invoke DeleteObject, eax
	invoke DeleteObject, hbit
	
	mov    font_HEX, FUNC(SendMessage, hWin, WM_GETFONT, 0, 0)
	invoke SelectObject,   dc, eax
	invoke GetTextMetrics, dc, ADDR tm
	mov    eax, tm.tmAveCharWidth
	inc    eax
	mov    font_cx, eax
	invoke ReleaseDC, hWin, dc
	
	xor    eax, eax
	mov    Cur_Model, eax
	mov    text_mode, eax
	
	mov    eax, color 
	mov    RGB_HEX,  eax
	mov    result,   eax
	invoke RGB_proc, eax, 0ffffffh
	invoke Set_Sliders_RGB
	
	ret

st_Init endp

st_Paint proc hWin:DWORD
	LOCAL ps:PAINTSTRUCT
	LOCAL offs_x:DWORD
	LOCAL offs_y:DWORD
	LOCAL cols:DWORD
	LOCAL rc:RECT 
	LOCAL val_[9]:BYTE
	LOCAL buf[32]:BYTE

	invoke BeginPaint, hWin, ADDR ps
	mov    eax, 10
	mov    rc.left, eax
	mov    rc.top,  30
	add    eax, 16
	mov    rc.right, eax
	mov    rc.bottom, 46
	mov    cols, 0
@@:	
	mov    ecx, OFFSET custom_pal
	add    ecx, cols
	invoke SetBkColor, ps.hdc, dword ptr [ecx]   
	invoke ExtTextOut, ps.hdc, 0, 0, ETO_OPAQUE, ADDR rc, 0, 0, 0
	add    cols, 4
	mov    eax, rc.right
	inc    eax 
	mov    rc.left,  eax
	add    eax, 16
	mov    rc.right, eax
	.if rc.right == 77
		mov    rc.left,   10
		mov    rc.right,  26
		mov    eax, rc.bottom
		inc    eax
		mov    rc.top,    eax
		add    eax, 16
		mov    rc.bottom, eax
	.endif
	cmp    cols, 24*4
	jz     @F
	jmp    @B
@@:	 
	;----------------------------- Draw frame for palette
	mov    offs_y, 29
@@:	
	invoke MoveToEx, ps.hdc,  9, offs_y, 0
	invoke LineTo,   ps.hdc, 61, offs_y
	add    offs_y, 17
	.if offs_y < 166
		jmp    @B
	.endif
	;----------------------------- Draw frame for palette
	mov    offs_x, 9
@@:	
	invoke MoveToEx, ps.hdc, offs_x, 29, 0
	invoke LineTo,   ps.hdc, offs_x, 166
	add    offs_x, 17
	.if offs_x < 61
		jmp    @B
	.endif
	;----------------------------- Draw sliders
	invoke GetSysColor, COLOR_BTNFACE
	invoke SetBkColor, mdc_RGB, eax
	invoke ExtTextOut, mdc_RGB, 0, 0, ETO_OPAQUE, ADDR RGB_rc, 0, 0, 0
	mov    offs_y, 8
	mov    offs_x, 0
@@:
	invoke SetPixelV, mdc_RGB, offs_x, offs_y, 0	
	add    offs_x, 3
	mov    ecx, slide_len1	
	.if offs_x <= ecx ;140
		jmp    @B
	.endif
	add    offs_y, 16
	mov    offs_x, 0
@@:
	invoke SetPixelV, mdc_RGB, offs_x, offs_y, 0	
	add    offs_x, 3
	mov    ecx, slide_len2
	.if offs_x <= ecx
		jmp    @B
	.endif
	add    offs_y, 16
	mov    offs_x, 0
@@:
	invoke SetPixelV, mdc_RGB, offs_x, offs_y, 0	
	add    offs_x, 3
	mov    ecx, slide_len3
	.if offs_x <= ecx
		jmp    @B
	.endif

	;------------------------------
	invoke DrawIconEx, mdc_RGB, cur_Rx,  2, cur_R, 13, 13, 0, 0, DI_NORMAL
	invoke DrawIconEx, mdc_RGB, cur_Gx, 18, cur_G, 13, 13, 0, 0, DI_NORMAL
	invoke DrawIconEx, mdc_RGB, cur_Bx, 34, cur_B, 13, 13, 0, 0, DI_NORMAL
	
	invoke BitBlt, ps.hdc, 70, 120, 140, 48, mdc_RGB, 0, 0, SRCCOPY
	;--------------------------------------------------------------
	invoke GetSysColor, COLOR_BTNFACE
	invoke SetBkColor, mdc_Cur, eax	
	invoke ExtTextOut, mdc_Cur, 0, 0, ETO_OPAQUE, ADDR Cur_rc1, 0, 0, 0
	invoke ExtTextOut, mdc_Cur, 0, 0, ETO_OPAQUE, ADDR Cur_rc2, 0, 0, 0
	invoke ExtTextOut, mdc_Cur, 0, 0, ETO_OPAQUE, ADDR Cur_rc3, 0, 0, 0
	
	invoke DrawIconEx, mdc_Cur, cur_RGBx, 19, cur_RGB, 13, 13, 0, 0, DI_NORMAL
	invoke BitBlt, ps.hdc, 70,  70, 140, 32, mdc_Cur, 0, 0, SRCCOPY
	
	invoke dw2hex, result, ADDR val_
	mov    offs_x, 8
	mov    offs_y, 0
	invoke GetSysColor, COLOR_BTNFACE
	invoke SetBkColor,   ps.hdc, eax
	invoke SelectObject, ps.hdc, font_HEX
	.if text_mode == 0
	@@:	
		mov    ecx, offset text_col
		mov    eax, offs_y
		shl    eax, 2
		add    ecx, eax
		invoke SetTextColor, ps.hdc, dword ptr [ecx]
		lea    ecx, val_
		add    ecx, offs_y
		invoke ExtTextOut, ps.hdc, offs_x, 6, ETO_OPAQUE, 0, ecx, 1, 0
		mov    eax, font_cx
		add    offs_x, eax
		inc    offs_y
		mov    eax, 9
		.if offs_y < eax
			jmp    @B
		.endif
	.else
		.if Cur_Model == 0
			invoke szCopy, ADDR text_rgb, ADDR buf
			xor    ecx, ecx
			mov    eax, offset result
			mov    cl, (RGB ptr [eax]).r
			invoke dwtoa, ecx, ADDR val_
			invoke szCatStr,   ADDR buf, ADDR val_
			invoke szCatStr,   ADDR buf, ADDR text_comma
			xor    ecx, ecx
			mov    eax, offset result
			mov    cl, (RGB ptr [eax]).g
			invoke dwtoa, ecx, ADDR val_
			invoke szCatStr,   ADDR buf, ADDR val_
			invoke szCatStr,   ADDR buf, ADDR text_comma
			xor    ecx, ecx
			mov    eax, offset result
			mov    cl, (RGB ptr [eax]).b
			invoke dwtoa, ecx, ADDR val_
			invoke szCatStr,   ADDR buf, ADDR val_
			invoke szCatStr,   ADDR buf, ADDR text_brac
			invoke lstrlen,    ADDR buf
			push   eax
			invoke ExtTextOut, ps.hdc, 8, 6, ETO_OPAQUE, 0, ADDR buf, eax, 0
			pop    eax
			mov    ecx, eax
			mov    edx, font_cx
			dec    edx
			mul    edx
			add    eax, 8
			mov    edx, 20
			sub    edx, ecx
			invoke ExtTextOut, ps.hdc, eax, 6, ETO_OPAQUE, 0, ADDR text_space, edx, 0
		.else
			invoke szCopy, ADDR text_hsl, ADDR buf
			xor    ecx, ecx
			mov    eax, offset result
			mov    cx, (HSL ptr [eax]).h
			invoke dwtoa, ecx, ADDR val_
			invoke szCatStr,   ADDR buf, ADDR val_
			invoke szCatStr,   ADDR buf, CADD(",")
			xor    ecx, ecx
			mov    eax, offset result
			mov    cl, (HSL ptr [eax]).s
			invoke dwtoa, ecx, ADDR val_
			invoke szCatStr,   ADDR buf, ADDR val_
			invoke szCatStr,   ADDR buf, CADD("%,")
			xor    ecx, ecx
			mov    eax, offset result
			mov    cl, (HSL ptr [eax]).l
			invoke dwtoa, ecx, ADDR val_
			invoke szCatStr,   ADDR buf, ADDR val_
			invoke szCatStr,   ADDR buf, CADD("%",29h)
			invoke lstrlen,    ADDR buf
			push   eax
			invoke ExtTextOut, ps.hdc, 8, 6, ETO_OPAQUE, 0, ADDR buf, eax, 0
			pop    eax
			mov    ecx, eax
			mov    edx, font_cx
			dec    edx
			mul    edx
			add    eax, 8
			mov    edx, 20
			sub    edx, ecx
			invoke ExtTextOut, ps.hdc, eax, 6, ETO_OPAQUE, 0, ADDR text_space, edx, 0
		.endif
	.endif
	
	invoke SetBkColor, ps.hdc, RGB_HEX
	invoke ExtTextOut, ps.hdc, 0, 0, ETO_OPAQUE, ADDR CCol_rc, 0, 0, 0
	
	invoke EndPaint, hWin, ADDR ps
	ret

st_Paint endp

st_Click proc hWin:DWORD, uMsg:DWORD, lParam:DWORD
	LOCAL x:DWORD
	LOCAL y:DWORD
	LOCAL pal:DWORD
	LOCAL rc:RECT
	LOCAL pt:POINT
	
	mov    eax, lParam
	and    eax, 0ffffh
	mov    x, eax
	mov    eax, lParam
	shr    eax, 16
	mov    y, eax
	
	.if uMsg==WM_LBUTTONDOWN
		mov    locked, 1
		invoke PtInRect, ADDR PAL_rc, x, y
		.if eax
			mov    eax, x
			sub    eax, 10
			mov    ecx, 17
			xor    edx, edx
			div    ecx
			mov    pal, eax
			mov    eax, y
			sub    eax, 30
			mov    ecx, 17
			xor    edx, edx
			div    ecx
			lea    eax, [eax+eax*2]
			add    pal, eax
			mov    eax, pal
			mov    ecx, offset custom_pal
			shl    eax, 2
			add    ecx, eax
			mov    eax, dword ptr [ecx]
			mov    cur_RGBx, 0
			mov    RGB_HEX, eax
			mov    result,  eax
			push   eax
			.if Cur_Model == 0
				invoke Set_Sliders_RGB
			.else
				mov    RGB_HEX, FUNC(RGB2HSL, RGB_HEX)
				mov    result,  eax
				invoke Set_Sliders_HSL
			.endif
			pop    RGB_HEX
			invoke RGB_proc, RGB_HEX, 0ffffffh
			invoke SendDlgItemMessage, hWin, 1005, CB_SETCURSEL, 0, 0
			invoke InvalidateRect, hWin, ADDR INV_rc0, 0
			invoke InvalidateRect, hWin, ADDR INV_rc1, 0
		.endif
	.endif

	invoke PtInRect, ADDR RGB_RC, x, y
	.if eax && locked == 1
		.if uMsg==WM_LBUTTONDOWN
			mov    locked, 1
			m2m    pt.x, RGB_RC.left
			m2m    pt.y, RGB_RC.top
			invoke ClientToScreen, hWin, ADDR pt
			m2m    rc.left,   pt.x
			m2m    rc.top,    pt.y
			m2m    pt.x, RGB_RC.right
			m2m    pt.y, RGB_RC.bottom
			invoke ClientToScreen, hWin, ADDR pt
			m2m    rc.right,  pt.x
			m2m    rc.bottom, pt.y
			invoke ClipCursor, ADDR rc
		.endif
		mov    eax, x
		sub    eax, 76
		mov    ecx, 127
		.if SDWORD ptr eax < 0
			mov    eax, 0
		.elseif eax > ecx
			mov    eax, ecx
		.endif
		mov    cur_RGBx, eax
		add    eax, 6
		invoke GetPixel, mdc_Cur, eax, 1
		mov    RGB_HEX, eax
		mov    result,  eax
		push   eax
		.if uMsg==WM_LBUTTONUP
			mov    locked, 0
			invoke ClipCursor, 0
			invoke SendDlgItemMessage, hWin, 1005, CB_SETCURSEL, 0, 0
		.endif
		.if Cur_Model == 0
			invoke Set_Sliders_RGB
		.else
			invoke RGB2HSL, RGB_HEX
			mov    RGB_HEX, eax
			mov    result,  eax
			invoke Set_Sliders_HSL
		.endif
		pop    RGB_HEX
		invoke InvalidateRect, hWin, ADDR INV_rc0, 0
		invoke InvalidateRect, hWin, ADDR INV_rc1, 0
		ret
	.endif
	
	invoke PtInRect, ADDR R_rc, x, y
	.if eax && locked == 1
		.if uMsg==WM_LBUTTONDOWN
			mov    locked, 1
			m2m    pt.x, R_rc.left
			m2m    pt.y, R_rc.top
			invoke ClientToScreen, hWin, ADDR pt
			m2m    rc.left,   pt.x
			m2m    rc.top,    pt.y
			m2m    pt.x, R_rc.right
			m2m    pt.y, R_rc.bottom
			invoke ClientToScreen, hWin, ADDR pt
			m2m    rc.right,  pt.x
			m2m    rc.bottom, pt.y
			invoke ClipCursor, ADDR rc
		.endif
		mov    eax, x
		sub    eax, 76
		mov    ecx, maxX1
		.if SDWORD ptr eax < 0
			mov    eax, 0
		.elseif eax > ecx
			mov    eax, ecx
		.endif
		mov    cur_Rx, eax
		mov    cur_RGBx, 0
		.if uMsg==WM_LBUTTONUP
			mov    locked, 0
			invoke ClipCursor, 0
			invoke SendDlgItemMessage, hWin, 1005, CB_SETCURSEL, 0, 0
		.endif
		.if Cur_Model == 0
			invoke Compute_RGB
			invoke RGB_proc, RGB_HEX, 0ffffffh
		.else
			invoke Compute_HSL
			invoke CreateHSLpal
			invoke HSL2RGB,  RGB_HEX
			mov    RGB_HEX,  eax
			invoke RGB_proc, RGB_HEX, 0ffffffh
		.endif
		invoke InvalidateRect, hWin, ADDR INV_rc0, 0
		invoke InvalidateRect, hWin, ADDR INV_rc1, 0
		ret
	.endif
	invoke PtInRect, ADDR G_rc, x, y
	.if eax && locked == 1
		.if uMsg==WM_LBUTTONDOWN
			mov    locked, 1
			m2m    pt.x, G_rc.left
			m2m    pt.y, G_rc.top
			invoke ClientToScreen, hWin, ADDR pt
			m2m    rc.left,   pt.x
			m2m    rc.top,    pt.y
			m2m    pt.x, G_rc.right
			m2m    pt.y, G_rc.bottom
			invoke ClientToScreen, hWin, ADDR pt
			m2m    rc.right,  pt.x
			m2m    rc.bottom, pt.y
			invoke ClipCursor, ADDR rc
		.endif
		mov    eax, x
		sub    eax, 76
		mov    ecx, maxX2
		.if SDWORD ptr eax < 0
			mov    eax, 0
		.elseif eax > ecx
			mov    eax, ecx
		.endif
		mov    cur_Gx, eax
		mov    cur_RGBx, 0
		.if uMsg==WM_LBUTTONUP
			mov    locked, 0
			invoke ClipCursor, 0
			invoke SendDlgItemMessage, hWin, 1005, CB_SETCURSEL, 0, 0
		.endif
		.if Cur_Model == 0
			invoke Compute_RGB
			invoke RGB_proc, RGB_HEX, 0ffffffh
		.else
			invoke Compute_HSL
			invoke HSL2RGB, RGB_HEX
			mov    RGB_HEX, eax
			invoke RGB_proc, RGB_HEX, 0ffffffh
		.endif
		invoke InvalidateRect, hWin, ADDR INV_rc0, 0
		invoke InvalidateRect, hWin, ADDR INV_rc1, 0
		ret
	.endif
	invoke PtInRect, ADDR B_rc, x, y
	.if eax && locked == 1
		.if uMsg==WM_LBUTTONDOWN
			mov    locked, 1
			m2m    pt.x, B_rc.left
			m2m    pt.y, B_rc.top
			invoke ClientToScreen, hWin, ADDR pt
			m2m    rc.left,   pt.x
			m2m    rc.top,    pt.y
			m2m    pt.x, B_rc.right
			m2m    pt.y, B_rc.bottom
			invoke ClientToScreen, hWin, ADDR pt
			m2m    rc.right,  pt.x
			m2m    rc.bottom, pt.y
			invoke ClipCursor, ADDR rc
		.endif
		mov    eax, x
		sub    eax, 76
		mov    ecx, maxX3
		.if SDWORD ptr eax < 0
			mov    eax, 0
		.elseif eax > ecx
			mov    eax, ecx
		.endif
		mov    cur_Bx, eax
		mov    cur_RGBx, 0
		.if uMsg==WM_LBUTTONUP
			mov    locked, 0
			invoke ClipCursor, 0
		.endif
		.if Cur_Model == 0
			invoke Compute_RGB
			invoke RGB_proc, RGB_HEX, 0ffffffh
		.else
			invoke Compute_HSL
			invoke HSL2RGB, RGB_HEX
			mov    RGB_HEX, eax
			invoke RGB_proc, RGB_HEX, 0ffffffh
		.endif
		invoke InvalidateRect, hWin, ADDR INV_rc0, 0
		invoke InvalidateRect, hWin, ADDR INV_rc1, 0
		ret
	.endif
	
	mov    locked, 0
	
	ret

st_Click endp

st_Comm proc hWin, wParam:DWORD
	LOCAL rgb_s[16]:BYTE
	
	.if wParam == 1006
		invoke DeleteDC,    mdc_RGB
		invoke DeleteDC,    mdc_Cur
		invoke DestroyIcon, cur_R
		invoke DestroyIcon, cur_G
		invoke DestroyIcon, cur_B
		invoke DestroyIcon, cur_RGB
		invoke DestroyMenu, col_popup
		invoke EndDialog,   hWin, result
	.elseif wParam == 1007
		invoke DeleteDC,    mdc_RGB
		invoke DeleteDC,    mdc_Cur
		invoke DestroyIcon, cur_R
		invoke DestroyIcon, cur_G
		invoke DestroyIcon, cur_B
		invoke DestroyIcon, cur_RGB
		invoke DestroyMenu, col_popup
		invoke EndDialog,   hWin, -1
	.elseif wParam == 10000
		.if text_mode==0
			mov    text_mode, 1
			invoke ModifyMenu, col_popup, 0, MF_BYPOSITION+MF_STRING, 10000, CADD("Toggle hex mode")
			invoke InvalidateRect, hWin, ADDR INV_rc0, 1
		.else
			mov    text_mode, 0
			invoke ModifyMenu, col_popup, 0, MF_BYPOSITION+MF_STRING, 10000, CADD("Toggle dec mode")
			invoke InvalidateRect, hWin, ADDR INV_rc0, 1
		.endif
	.endif
	mov    eax, wParam
	shr    eax, 16
	mov    ecx, wParam
	and    ecx, 0ffffh
	.if eax == CBN_SELCHANGE
		.if ecx == 1004
			invoke SendDlgItemMessage, hWin, 1004, CB_GETCURSEL, 0, 0
			.if eax == 0 && Cur_Model == 1
				mov    Cur_Model, 0
				mov    eax,     RGB_HEX
				mov    result,  eax
				invoke Set_Sliders_RGB
				invoke MemCopy, ADDR standard_pal, ADDR custom_pal, 4*24
				;----------------------------
				mov    eax, 140 ; 128 + 6 + 6
				mov    slide_len1, eax
				mov    slide_len2, eax
				mov    slide_len3, eax
				;----------------------------
				mov    eax, 127
				mov    maxX1, eax
				mov    maxX2, eax
				mov    maxX3, eax
				;----------------------------
				mov    eax, OFFSET text_col
				mov    DWORD ptr [eax+ 0],       0h
				mov    DWORD ptr [eax+ 4],       0h
				mov    DWORD ptr [eax+ 8], 0ff0000h
				mov    DWORD ptr [eax+12], 0ff0000h
				mov    DWORD ptr [eax+16],    8000h
				mov    DWORD ptr [eax+20],    8000h
				mov    DWORD ptr [eax+24],     0ffh
				mov    DWORD ptr [eax+28],     0ffh
				invoke InvalidateRect, hWin, ADDR INV_rc0, 0
				invoke InvalidateRect, hWin, ADDR INV_rc1, 0
			.elseif eax == 1 && Cur_Model == 0
				mov    Cur_Model, 1
				mov    eax, RGB_HEX
				push   eax
				mov    RGB_HEX, FUNC(RGB2HSL, eax)
				mov    result,  eax
				invoke CreateHSLpal
				invoke Set_Sliders_HSL
				pop    RGB_HEX
				;----------------------------
				mov    eax, 132 ; 120 + 6 + 6
				mov    slide_len1, eax
				mov    eax, 112 ; 100 + 6 + 6
				mov    slide_len2, eax
				mov    slide_len3, eax
				;----------------------------
				mov    eax, 120
				mov    maxX1, eax
				mov    eax, 100
				mov    maxX2, eax
				mov    maxX3, eax
				;----------------------------
				mov    eax, OFFSET text_col
				mov    DWORD ptr [eax+ 0], 808000h
				mov    DWORD ptr [eax+ 4], 808000h
				mov    DWORD ptr [eax+ 8],   8080h
				mov    DWORD ptr [eax+12],   8080h
				mov    DWORD ptr [eax+16], 800080h
				mov    DWORD ptr [eax+20], 800080h
				mov    DWORD ptr [eax+24], 800080h
				mov    DWORD ptr [eax+28], 800080h
				invoke InvalidateRect, hWin, ADDR INV_rc0, 0
				invoke InvalidateRect, hWin, ADDR INV_rc1, 0
			.endif
		.elseif ecx == 1005
			invoke SendDlgItemMessage, hWin, 1005, CB_GETCURSEL, 0, 0
			.if eax
				dec    eax
				mov    result, eax
				invoke GetSysColor, eax
				mov    RGB_HEX, eax
				invoke RGB_proc, eax, 0ffffffh
				.if Cur_Model == 0
					invoke Set_Sliders_RGB
				.endif
				or     result, 80000000h
				invoke InvalidateRect, hWin, ADDR INV_rc0, 0
				invoke InvalidateRect, hWin, ADDR INV_rc1, 0
			.endif
		.endif
	.endif
	xor    eax, eax
	ret

st_Comm endp

st_Popup proc hWin:DWORD
	LOCAL pt:POINT
	
	invoke GetCursorPos, ADDR pt
	invoke ScreenToClient, hWin, ADDR pt
	invoke PtInRect, ADDR INV_rc0, pt.x, pt.y
	.if eax
		invoke ClientToScreen, hWin, ADDR pt
		invoke TrackPopupMenuEx, col_popup, TPM_LEFTALIGN, pt.x, pt.y, hWin, 0
	.endif
	
	ret

st_Popup endp

RGB2HSL proc rgb:DWORD
	LOCAL R_:DWORD
	LOCAL G_:DWORD
	LOCAL B_:DWORD
	LOCAL tem:DWORD
	LOCAL min_:DWORD
	LOCAL max_:DWORD
	LOCAL h:DWORD
	LOCAL s:DWORD
	LOCAL l:DWORD
	LOCAL H_:REAL8
	LOCAL S_:REAL8
	LOCAL L_:REAL8
	LOCAL var_R:REAL8
	LOCAL var_G:REAL8
	LOCAL var_B:REAL8
	LOCAL del_R:REAL8
	LOCAL del_G:REAL8
	LOCAL del_B:REAL8
	LOCAL var_Min:REAL8
	LOCAL var_Max:REAL8
	LOCAL del_Max:REAL8

	xor    ecx, ecx
	mov    eax, rgb
	mov    cl,  al
	mov    R_,  ecx
	mov    min_, ecx
	mov    max_, ecx
	
	shr    eax, 8
	mov    cl,  al
	mov    G_,  ecx
	.if ecx < min_
		mov    min_, ecx
	.elseif ecx > max_
		mov    max_, ecx	
	.endif
	
	shr    eax, 8
	mov    cl,  al
	mov    B_,  ecx
	.if ecx < min_
		mov    min_, ecx
	.elseif ecx > max_
		mov    max_, ecx	
	.endif
	
	mov    tem, 255
	
	finit
	;---------- we have R/255
	fild   R_
	fild   tem
	fdiv
	fstp   var_R
	;----------- we have G/255
	fild   G_
	fild   tem
	fdiv
	fstp   var_G
	;----------- we have B/255
	fild   B_
	fild   tem
	fdiv
	fstp   var_B
	;----------- we have min/255
	fild   min_
	fild   tem
	fdiv
	fstp   var_Min
	;----------- we have max/255
	fild   max_
	fild   tem
	fdiv
	fstp   var_Max
	;----------- we have del_max
	fld    var_Max
	fld    var_Min
	fsub
	fstp   del_Max
	;----------- we have L
	mov    tem, 2
	fld    var_Max
	fld    var_Min
	fadd
	fild   tem
	fdiv
	fstp   L_
	;----------- if del_Max != 0 jump somewhere
	fld    del_Max
	fldz
	fcompp
	fstsw  ax
	sahf
	jnz    @F
	fldz
	fst    H_
	fst    S_
	jmp    @store
@@:	
	fld    R05
	fld    L_
	fcompp
	fstsw  ax
	sahf
	jae    @F
	;----------
	fld    del_Max
	fld    var_Max
	fld    var_Min
	fadd
	fdiv
	fstp   S_
	jmp    @st2
@@:	
	fld    del_Max
	fild   tem
	fld    var_Max
	fld    var_Min
	fsub
	fsub
	fdiv
	fstp   S_
@st2:	
	;------------ we have del_R
	mov    tem, 6
	fld    var_Max
	fld    var_R
	fsub
	fild   tem
	fdiv
	;..
	mov    tem, 2
	fld    del_Max
	fild   tem
	fdiv
	fadd
	fld    del_Max
	fdiv
	fstp   del_R
	;------------ we have del_G
	mov    tem, 6
	fld    var_Max
	fld    var_G
	fsub
	fild   tem
	fdiv
	;..
	mov    tem, 2
	fld    del_Max
	fild   tem
	fdiv
	fadd
	fld    del_Max
	fdiv
	fstp   del_G
	;------------ we have del_R
	mov    tem, 6
	fld    var_Max
	fld    var_B
	fsub
	fild   tem
	fdiv
	;..
	mov    tem, 2
	fld    del_Max
	fild   tem
	fdiv
	fadd
	fld    del_Max
	fdiv
	fstp   del_B
	
	mov    eax, max_
	.if R_ == eax
		fld    del_B
		fld    del_G
		fsub
	.elseif G_ == eax
		mov    tem, 3
		fld1
		fild   tem
		fdiv
		fld    del_R
		fld    del_B
		fsub
		fadd
	.elseif B_ == eax
		mov    tem, 2
		fild   tem
		mov    tem, 3
		fild   tem
		fdiv
		fld    del_G
		fld    del_R
		fsub
		fadd
	.endif
	fst    H_
	fldz
	fcomp
	fstsw  ax
	sahf
	jbe    @check
	fld1 ;+1
	fadd
@check:	
	fld1
	fcomp
	fstsw  ax
	sahf
	jae    @store
	fld1 ;-1
	fsub
@store:	
	mov    tem, 360
	fild   tem
	fmul
	fistp  h
	
	mov    tem, 100
	fld    S_
	fild   tem
	fmul
	fistp  s
	
	fld    L_
	fild   tem
	fmul
	fistp  l
	
	xor    eax, eax
	mov    ecx, l
	mov    al, cl
	shl    eax, 8
	mov    ecx, s
	mov    al, cl
	shl    eax, 16
	mov    ecx, h
	mov    ax, cx
	
	ret

RGB2HSL endp

HSL2RGB proc hsl:DWORD
	LOCAL h:DWORD
	LOCAL s:DWORD
	LOCAL l:DWORD
	LOCAL h_:REAL8
	LOCAL s_:REAL8
	LOCAL l_:REAL8
	LOCAL var_1:REAL8
	LOCAL var_2:REAL8
	LOCAL var_3:REAL8
	LOCAL tem_R:REAL8
	LOCAL tem_G:REAL8
	LOCAL tem_B:REAL8
	LOCAL vH:REAL8
	LOCAL tem:DWORD
	;-----------
	LOCAL r:DWORD
	LOCAL g:DWORD
	LOCAL b:DWORD
	
	mov    eax, hsl
	and    eax, 0ffffh
	mov    h, eax
	mov    eax, hsl
	shr    eax, 16
	and    eax, 0ffh
	mov    s, eax
	mov    eax, hsl
	shr    eax, 24
	mov    l, eax
	;------------
	mov    tem, 360 ; H ranges 0..360
	finit
	fild   h
	fild   tem
	fdiv
	fstp   h_
	;++
	mov    tem, 100 ; S,L ranges 0..100
	fild   s
	fild   tem
	fdiv
	fstp   s_
	;++
	fild   l
	fild   tem
	fdiv
	fstp   l_
	;++
	.if s == 0
		mov    tem, 255
		fld    l_
		fild   tem
		fmul
		fist   r
		fist   g
		fistp  b
		jmp    @fin
	.else
		mov    ecx, 3 ; for R for G for B
		fld    R05
		fld    l_
		fcompp
		fstsw  ax
		sahf
		jae    @F
		fld    l_
		fld1
		fld    s_
		fadd
		fmul
		jmp    @st1
	@@:	
		fld    l_
		fld    s_
		fadd
		fld    s_
		fld    l_
		fmul
		fsub
	@st1:
		fstp   var_2
		;-----------
		mov    tem, 2
		fild   tem
		fld    l_
		fmul
		fld    var_2
		fsub
		fstp   var_1
		;-----------------
	@nextRGB:	
		mov    tem, 3
		fld    h_    ; ecx == 2
		.if ecx == 3
			fld1
			fild   tem
			fdiv
			fadd
		.elseif ecx == 1
			fld1
			fild   tem
			fdiv
			fsub
		.endif
		fldz
		fcomp
		fstsw  ax
		sahf
		jbe    @F
		fld1
		fadd
	@@:	
		fld1
		fcomp
		fstsw  ax
		sahf
		jae    @F
		fld1
		fsub
	@@:	
		fstp   vH
		fld1
		mov    tem, 6
		fild   tem
		fld    vH
		fmul
		fcompp
		fstsw  ax
		sahf
		jae     @F
		fld    var_1
		fld    var_2
		fld    var_1
		fsub
		fild   tem
		fld    vH
		fmul
		fmul
		fadd
		jmp     @saveRGB
	@@:
		mov     tem, 2
		fld1
		fild    tem
		fld     vH
		fmul
		fcompp
		fstsw   ax
		sahf
		jae     @F
		fld     var_2
		jmp     @saveRGB
	@@:
		mov     tem, 2
		fild    tem
		mov     tem, 3
		fild    tem
		fld     vH
		fmul
		fcompp
		fstsw   ax
		sahf
		jae     @F
		mov     tem, 2
		fld     var_1
		fld     var_2
		fld     var_1
		fsub
		fild    tem
		mov     tem, 3
		fild    tem
		fdiv
		fld     vH
		fsub
		mov     tem, 6
		fild    tem
		fmul
		fmul
		fadd
		jmp     @saveRGB
	@@:
		fld     var_1
	@saveRGB:
		mov    tem, 255
		fild   tem
		fmul
		.if ecx == 3
			fistp  r
		.elseif ecx == 2
			fistp  g
		.elseif ecx == 1
			fistp  b
		.endif
		dec    ecx
		cmp    ecx, 0
		jg     @nextRGB
	.endif
@fin:
	xor    eax, eax
	mov    ecx, b
	mov    al,  cl
	shl    eax, 8
	mov    ecx, g
	mov    al,  cl
	shl    eax, 8
	mov    ecx, r
	mov    al,  cl
	
	ret

HSL2RGB endp

CreateHSLpal proc
	LOCAL S_Offs:BYTE
	LOCAL L_Offs:BYTE
	LOCAL H_Val:WORD 
	LOCAL counter:DWORD
	
	mov    S_Offs,  60
	mov    L_Offs,  80
	mov    eax, RGB_HEX
	mov    H_Val,   ax
	mov    counter, 0
	mov    esi, OFFSET custom_pal
	xor    edx, edx
@@:	
	xor    eax, eax
	mov    al,  L_Offs
	shl    eax, 8
	mov    al,  S_Offs
	shl    eax, 16
	mov    ax,  H_Val
	;------------------
	invoke HSL2RGB, eax
	mov    ecx, counter
	mov    DWORD ptr [esi+ecx*4], eax
	sub    S_Offs, 20
	inc    edx
	.if edx == 3
		mov    edx, 0
		mov    S_Offs, 60
		sub    L_Offs, 10
	.endif
	inc    counter
	cmp    counter, 24
	jnz    @B
	ret

CreateHSLpal endp

Compute_RGB proc
	
	xor    ecx, ecx
	mov    eax, cur_Bx
	shl    eax, 1
	.if eax==254
		inc eax
	.endif
	mov    ecx, eax
	shl    ecx, 8
	mov    eax, cur_Gx
	shl    eax, 1
	.if eax==254
		inc eax
	.endif
	mov    cl, al
	shl    ecx, 8
	mov    eax, cur_Rx
	shl    eax, 1
	.if eax==254
		inc eax
	.endif
	mov    cl, al
	mov    RGB_HEX, ecx
	mov    result,  ecx
	
	ret

Compute_RGB endp

Compute_HSL proc
	
	xor    ecx, ecx
	mov    eax, cur_Bx
	mov    ecx, eax
	shl    ecx, 8
	mov    eax, cur_Gx
	mov    cl, al
	shl    ecx, 16
	mov    eax, cur_Rx
	lea    eax, [eax+eax*2]
	mov    cx, ax
	mov    RGB_HEX, ecx
	mov    result,  ecx
	
	ret

Compute_HSL endp

Set_Sliders_RGB proc
	
	xor    eax, eax
	mov    ecx, RGB_HEX
	mov    al, cl
	shr    eax, 1
	mov    cur_Rx, eax
	
	shr    ecx, 8
	mov    al, cl
	shr    eax, 1
	mov    cur_Gx, eax
	
	shr    ecx, 8
	mov    al, cl
	shr    eax, 1
	mov    cur_Bx, eax
	
	ret

Set_Sliders_RGB endp

Set_Sliders_HSL proc
	
	xor    eax, eax
	mov    ecx, RGB_HEX
	mov    ax, cx
	mov    ecx, 3
	xor    edx, edx
	div    ecx
	mov    cur_Rx, eax
	
	xor    eax, eax
	mov    ecx, RGB_HEX
	shr    ecx, 16
	mov    al, cl
	mov    cur_Gx, eax
	
	shr    ecx, 8
	mov    al, cl
	mov    cur_Bx, eax
	
	ret

Set_Sliders_HSL endp

RGB_proc PROC F_S:DWORD, F_E:DWORD
	LOCAL S_R:DWORD, S_G:DWORD, S_B:DWORD
	LOCAL E_R:DWORD, E_G:DWORD, E_B:DWORD
	LOCAL gal:RECT
	LOCAL R:BYTE, G:BYTE, B:BYTE, XXX:DWORD

	mov    eax, F_S
	and    eax, 000000FFh
	mov    S_R, eax
	mov    eax, F_S
	shr    eax, 8
	and    eax, 000000FFh
	mov    S_G, eax
	mov    eax, F_S
	shr    eax, 16
	and    eax, 000000FFh
	mov    S_B, eax
	mov    eax, F_E
	and    eax, 000000FFh
	sub    eax, S_R
	mov    E_R, eax
	mov    eax, F_E
	shr    eax, 8
	and    eax, 000000FFh
	sub    eax, S_G
	mov    E_G, eax
	mov    eax, F_E
	shr    eax, 16
	and    eax, 000000FFh
	sub    eax, S_B
	mov    E_B, eax
	mov    gal.top,     0
	mov    gal.bottom, 19
	mov    XXX, 0
here:
	invoke MulDiv, XXX, 128, 255
	add    eax, 6
	mov    gal.left, eax
	mov    eax, XXX
	inc    eax
	invoke MulDiv, eax, 128, 255
	add    eax, 6
	mov    gal.right, eax
	
	invoke MulDiv, XXX, E_R, 255
	add    eax, S_R
	mov    R, al
	invoke MulDiv, XXX, E_G, 255
	add    eax, S_G
	mov    G, al
	invoke MulDiv, XXX, E_B, 255
	add    eax, S_B
	mov    B, al
	RGB_   R, G, B
	invoke SetBkColor, mdc_Cur, eax
	invoke ExtTextOut, mdc_Cur, 0, 0, ETO_OPAQUE, ADDR gal, 0, 0, 0
	inc    XXX
	.IF    XXX < 255
		jmp here
	.ELSEIF XXX==255
		ret
	.ENDIF
	ret
RGB_proc ENDP

End DllEntry